//sussy check 
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and (player.mo.skin == "amongus")
		player.therealsussy = true
	else
		player.therealsussy = false
	end
end)


//effect for dash mode
freeslot("S_SUSSY_FIRETRAIL")
states[S_SUSSY_FIRETRAIL] = {
	sprite = SPR_SFLM,
	frame = A|FF_ANIMATE,
	tics = 27,
	nextstate = S_NULL,
	var1 = 2,
	var2 = 2
}
addHook("PlayerThink", function(player)
if player.therealsussy
	if (player.dashmode >= (3*TICRATE))
	    player.sussydashmodetics = $+1
	local mo = player.mo
		P_SpawnGhostMobj(player.mo)
		if leveltime%10 == 0
		and P_IsObjectOnGround(player.mo)
		and player.sussydashmodetics >= 70
		and player.speed >= 50*FRACUNIT
			for i = -1, 1, 2
				local ang = i * ANG10
				local factor = FixedMul(4*mo.scale, cos(ang))
				local x = P_ReturnThrustX(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
				local y = P_ReturnThrustY(mo, player.drawangle + ANGLE_180 + ang, 24*mo.scale)
				local dust = P_SpawnMobjFromMobj(mo, x, y, 0, MT_THOK)
				dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
				dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
				dust.scale = mo.scale
				dust.angle = R_PointToAngle2(dust.x, dust.y, mo.x, mo.y)
				dust.state = S_SUSSY_FIRETRAIL
				dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
				dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
				end
			end
	else
	player.sussydashmodetics = 0
		end
	end
end)

//new crouch
addHook("PlayerThink", function(player)
if player.therealsussy
     if(player.cmd.buttons & BT_CUSTOM1)
	 and P_IsObjectOnGround(player.mo)
	       player.height = 30*FRACUNIT
		   player.pflags = $|PF_FULLSTASIS
		   player.mo.state = S_PLAY_ROLL
		   player.crouch = true
           else
           player.height = 45*FRACUNIT
		   player.pflags = $ & ~PF_FULLSTASIS
     end
	 if not (player.cmd.buttons & BT_CUSTOM1)
	 and player.crouch      
	      player.mo.state = S_PLAY_STND
		  player.crouch = false
	 end
end
end)

//panic
addHook("ThinkFrame", function()
     for player in players.iterate do
	 	 if not player.therealsussy
		return
		end
  if ((player.mo.state == S_PLAY_STND))
	and ((PTSR and PTSR.pizzatime)
	or (PTV3 and PTV3.pizzatime)) then
				player.mo.state = S_PLAY_FLY
		end
  if (player.mo.state == S_PLAY_FLY)
	   and player.speed >= 1*FRACUNIT then
				player.mo.state = S_PLAY_WALK
	end
	end
end)

//double jump animation
freeslot("S_PLAY_DOUBLEJUMP")
states[S_PLAY_DOUBLEJUMP] = {
        sprite = SPR_PLAY,
        frame = SPR2_SPNG|A|FF_ANIMATE,
        tics = -1,
		var1 = 2,
	    var2 = 2,
}

addHook("PlayerThink", do
    for player in players.iterate do
		if player.therealsussy
		and player.cmd.buttons & BT_JUMP
		and ((player.mo.state == S_PLAY_JUMP)
		or (player.mo.state == S_PLAY_FALL)
		or (player.mo.state == S_PLAY_MELEE)
		or (player.mo.state == S_PLAY_MELEE_FINISH))
		and not P_IsObjectOnGround(player.mo)
		and player.punchedtimes >= 1
		and (player.pflags & PF_THOKKED) then 
			player.mo.state = S_PLAY_DOUBLEJUMP
		end
	end
end)

//punch
addHook("PlayerThink", function(p)
	if p.susspintimr == nil
		p.susspintimr = 0
	end
	if (p.cmd.buttons & BT_SPIN)
		p.susspintimr = $1+1
	else
		p.susspintimr = 0
	end
end)

addHook("PlayerThink", function(player)
if player.therealsussy
	if player.punchedground == nil
	      player.punchedground = false
	end
	if player.susspintimr == 1
	and not P_IsObjectOnGround(player.mo)
    and not ((player.mo.state == S_PLAY_MELEE)or(player.mo.state == S_PLAY_DOUBLEJUMP) or (player.mo.state == S_PLAY_DEAD) or (player.mo.state == S_PLAY_PAIN) or (player.mo.state == S_PLAY_ROLL) or (player.mo.state == S_PLAY_MELEE_FINISH))
	and player.punchedtimes >= 1
		  player.mo.state = S_PLAY_MELEE
		  player.punchedtimes = $-1
		  P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT) 
		  P_SetObjectMomZ(player.realmo, 7*FRACUNIT, false)
		  if player.speed <= 40*FRACUNIT
		         P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT) 
		         else
		         P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy)) 
	      end
	end
	if player.susspintimr == 1
	and not P_IsObjectOnGround(player.mo)
	and (player.mo.state == S_PLAY_DOUBLEJUMP)
	and player.punchedtimes >= 1
		  player.mo.state = S_PLAY_MELEE
		  player.punchedtimes = $-2
		  P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT) 
		  P_SetObjectMomZ(player.realmo, 7*FRACUNIT, false)
		  if player.speed <= 40*FRACUNIT
		        P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT) 
		        else
		        P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy)) 
	      end
	end
	if P_IsObjectOnGround(player.mo)
	      player.punchedtimes = 2
	end
	if player.punchedgroundspeed == nil
	      player.punchedgroundspeed = 47
	end
	if player.punchedtimes == nil
	      player.punchedtimes = 2
	end
	if player.susspintimr == 1
	and not player.crouch    
	and not ((player.mo.state == S_PLAY_MELEE) or (player.mo.state == S_PLAY_ROLL) or (player.mo.state == S_PLAY_MELEE_FINISH))
	and not player.punchedground
	and P_IsObjectOnGround(player.mo)
		  player.mo.state = S_PLAY_MELEE
		  player.punchedground = true
    end
    if player.punchedground
	and P_IsObjectOnGround(player.mo) 
	      player.mo.state = S_PLAY_MELEE
	      player.punchedgroundspeed = $-2
	      P_InstaThrust(player.mo, player.punchangle, player.punchedgroundspeed*FRACUNIT)
	      else
	      player.punchangle = player.drawangle
	      player.punchedground = false
	      player.punchedgroundspeed = 47
	end
	if player.punchedground
	and player.punchedgroundspeed <= 3
	     player.punchedgroundspeed = 47
	     player.punchedground = false
	     player.mo.state = S_PLAY_STND
	end
	if ((player.mo.state == S_PLAY_MELEE) or (player.mo.state == S_PLAY_MELEE_FINISH))
	     player.powers[pw_strong] = STR_SPRING|STR_ANIM|STR_WALL|STR_SPIKE|STR_PUNCH
	end
end
end)
